#include "NewDialog.h"

//(*InternalHeaders(NewDialog)
#include <wx/string.h>
#include <wx/intl.h>
//*)
#include <wx/filedlg.h>
#include <wx/filename.h>
#include <wx/colordlg.h>
#include <wx/cmndata.h>

#include <ctime>
#include <cstdlib>

#include "struct.h"
#include "TextCtrl.h"

//float randf(float min, float max);

//(*IdInit(NewDialog)
const long NewDialog::ID_Bots = wxNewId();
const long NewDialog::ID_AddBot = wxNewId();
const long NewDialog::ID_DelBot = wxNewId();
const long NewDialog::ID_DelAll = wxNewId();
const long NewDialog::ID_Comment = wxNewId();
const long NewDialog::ID_Color = wxNewId();
const long NewDialog::ID_STATICTEXT1 = wxNewId();
const long NewDialog::ID_NumBots = wxNewId();
const long NewDialog::ID_STATICTEXT2 = wxNewId();
const long NewDialog::ID_StartNrg = wxNewId();
const long NewDialog::ID_STATICTEXT3 = wxNewId();
const long NewDialog::ID_StartBody = wxNewId();
const long NewDialog::ID_Veggy = wxNewId();
const long NewDialog::ID_Fixed = wxNewId();
const long NewDialog::ID_NoVis = wxNewId();
const long NewDialog::ID_NoExec = wxNewId();
const long NewDialog::ID_PANEL1 = wxNewId();
const long NewDialog::ID_STATICTEXT4 = wxNewId();
const long NewDialog::ID_FieldWidth = wxNewId();
const long NewDialog::ID_STATICTEXT5 = wxNewId();
const long NewDialog::ID_FieldHeight = wxNewId();
const long NewDialog::ID_STATICTEXT6 = wxNewId();
const long NewDialog::ID_MaxNonVeg = wxNewId();
const long NewDialog::ID_STATICTEXT7 = wxNewId();
const long NewDialog::ID_MaxVeg = wxNewId();
const long NewDialog::ID_STATICTEXT8 = wxNewId();
const long NewDialog::ID_VegRepopThreshold = wxNewId();
const long NewDialog::ID_STATICTEXT9 = wxNewId();
const long NewDialog::ID_VegRepopAmount = wxNewId();
const long NewDialog::ID_STATICTEXT25 = wxNewId();
const long NewDialog::ID_VegRepopCooldown = wxNewId();
const long NewDialog::ID_VegNrg = wxNewId();
const long NewDialog::ID_STATICTEXT10 = wxNewId();
const long NewDialog::ID_NrgPerCycle = wxNewId();
const long NewDialog::ID_NrgPerKilobody = wxNewId();
const long NewDialog::ID_PANEL2 = wxNewId();
const long NewDialog::ID_STATICTEXT11 = wxNewId();
const long NewDialog::ID_Friction = wxNewId();
const long NewDialog::ID_STATICTEXT12 = wxNewId();
const long NewDialog::ID_Density = wxNewId();
const long NewDialog::ID_STATICTEXT13 = wxNewId();
const long NewDialog::ID_Elast = wxNewId();
const long NewDialog::ID_STATICTEXT23 = wxNewId();
const long NewDialog::ID_MoveEff = wxNewId();
const long NewDialog::ID_STATICTEXT24 = wxNewId();
const long NewDialog::ID_MaxVel = wxNewId();
const long NewDialog::ID_PANEL3 = wxNewId();
const long NewDialog::ID_STATICTEXT14 = wxNewId();
const long NewDialog::ID_StoreCost = wxNewId();
const long NewDialog::ID_STATICTEXT15 = wxNewId();
const long NewDialog::ID_MovCost = wxNewId();
const long NewDialog::ID_STATICTEXT16 = wxNewId();
const long NewDialog::ID_AgeCost = wxNewId();
const long NewDialog::ID_STATICTEXT17 = wxNewId();
const long NewDialog::ID_ShotCost = wxNewId();
const long NewDialog::ID_STATICTEXT18 = wxNewId();
const long NewDialog::ID_BodyUpkeepCost = wxNewId();
const long NewDialog::ID_STATICTEXT19 = wxNewId();
const long NewDialog::ID_PoisonCost = wxNewId();
const long NewDialog::ID_STATICTEXT20 = wxNewId();
const long NewDialog::ID_VenomCost = wxNewId();
const long NewDialog::ID_STATICTEXT21 = wxNewId();
const long NewDialog::ID_SlimeCost = wxNewId();
const long NewDialog::ID_STATICTEXT22 = wxNewId();
const long NewDialog::ID_ShellCost = wxNewId();
const long NewDialog::ID_PANEL4 = wxNewId();
const long NewDialog::ID_NOTEBOOK1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(NewDialog,wxDialog)
	//(*EventTable(NewDialog)
	//*)
END_EVENT_TABLE()

NewDialog::NewDialog(wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size)
{
	//(*Initialize(NewDialog)
	wxStaticText* StaticText24;
	wxStaticBoxSizer* StaticBoxSizer2;
	wxStaticText* StaticText22;
	wxFlexGridSizer* FlexGridSizer8;
	wxFlexGridSizer* FlexGridSizer1;
	wxFlexGridSizer* FlexGridSizer2;
	wxPanel* Panel1;
	wxStaticText* StaticText21;
	wxStaticText* StaticText13;
	wxStaticText* StaticText14;
	wxStaticText* StaticText15;
	wxStaticText* StaticText17;
	wxButton* DelAll;
	wxFlexGridSizer* FlexGridSizer11;
	wxButton* Button2;
	wxFlexGridSizer* FlexGridSizer7;
	wxStaticText* StaticText20;
	wxStaticText* StaticText18;
	wxBoxSizer* BoxSizer2;
	wxFlexGridSizer* FlexGridSizer4;
	wxStaticText* StaticText1;
	wxStaticText* StaticText10;
	wxFlexGridSizer* FlexGridSizer9;
	wxStaticText* StaticText16;
	wxStaticBoxSizer* StaticBoxSizer3;
	wxFlexGridSizer* FlexGridSizer14;
	wxFlexGridSizer* FlexGridSizer6;
	wxPanel* Panel2;
	wxStaticText* StaticText3;
	wxPanel* Panel4;
	wxStaticText* StaticText23;
	wxFlexGridSizer* FlexGridSizer3;
	wxStaticText* StaticText8;
	wxStaticText* StaticText12;
	wxPanel* Panel3;
	wxStaticText* StaticText7;
	wxStaticText* StaticText4;
	wxFlexGridSizer* FlexGridSizer10;
	wxBoxSizer* BoxSizer1;
	wxFlexGridSizer* FlexGridSizer13;
	wxStaticText* StaticText5;
	wxStaticText* StaticText2;
	wxNotebook* Notebook1;
	wxStaticText* StaticText6;
	wxFlexGridSizer* FlexGridSizer12;
	wxStaticText* StaticText19;
	wxFlexGridSizer* FlexGridSizer5;
	wxStaticText* StaticText9;
	wxBoxSizer* BoxSizer6;
	wxStdDialogButtonSizer* StdDialogButtonSizer1;
	wxStaticText* StaticText11;
	wxStaticText* StaticText25;
	wxStaticBoxSizer* StaticBoxSizer1;

	Create(parent, wxID_ANY, _("New simulation"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(2, 1, 0, 0);
	Notebook1 = new wxNotebook(this, ID_NOTEBOOK1, wxDefaultPosition, wxDefaultSize, 0, _T("ID_NOTEBOOK1"));
	Panel1 = new wxPanel(Notebook1, ID_PANEL1, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL1"));
	FlexGridSizer10 = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer10->AddGrowableCol(0);
	FlexGridSizer10->AddGrowableRow(0);
	FlexGridSizer11 = new wxFlexGridSizer(1, 3, 0, 0);
	FlexGridSizer11->AddGrowableCol(0);
	FlexGridSizer11->AddGrowableCol(2);
	FlexGridSizer11->AddGrowableRow(0);
	Bots = new wxListCtrl(Panel1, ID_Bots, wxDefaultPosition, wxDefaultSize, wxLC_LIST|wxLC_NO_HEADER|wxLC_SINGLE_SEL|wxSUNKEN_BORDER, wxDefaultValidator, _T("ID_Bots"));
	Bots->SetMinSize(wxSize(100,150));
	FlexGridSizer11->Add(Bots, 1, wxALL|wxEXPAND|wxFIXED_MINSIZE|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer1 = new wxBoxSizer(wxVERTICAL);
	Button2 = new wxButton(Panel1, ID_AddBot, _("Add bot"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_AddBot"));
	Button2->SetFocus();
	BoxSizer1->Add(Button2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	DelBot = new wxButton(Panel1, ID_DelBot, _("Remove bot"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_DelBot"));
	DelBot->Disable();
	BoxSizer1->Add(DelBot, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	DelAll = new wxButton(Panel1, ID_DelAll, _("Remove all"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_DelAll"));
	BoxSizer1->Add(DelAll, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer11->Add(BoxSizer1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Comment = new wxTextCtrl(Panel1, ID_Comment, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_AUTO_SCROLL|wxTE_MULTILINE|wxTE_READONLY, wxDefaultValidator, _T("ID_Comment"));
	FlexGridSizer11->Add(Comment, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer10->Add(FlexGridSizer11, 0, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 3, 0, 0);
	Color = new wxButton(Panel1, ID_Color, _("Set bot color..."), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_Color"));
	Color->Disable();
	FlexGridSizer2->Add(Color, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(3, 2, 0, 0);
	StaticText1 = new wxStaticText(Panel1, ID_STATICTEXT1, _("Number of bots"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer3->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	NumBots = new wxIntTextCtrl(Panel1, ID_NumBots, _("0"), wxDefaultPosition, wxSize(64,-1), 0, wxDefaultValidator, _T("ID_NumBots"));
	NumBots->Disable();
	FlexGridSizer3->Add(NumBots, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText2 = new wxStaticText(Panel1, ID_STATICTEXT2, _("Starting energy"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer3->Add(StaticText2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StartNrg = new wxIntTextCtrl(Panel1, ID_StartNrg, _("0"), wxDefaultPosition, wxSize(64,-1), 0, wxDefaultValidator, _T("ID_StartNrg"));
	StartNrg->Disable();
	FlexGridSizer3->Add(StartNrg, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(Panel1, ID_STATICTEXT3, _("Starting body"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer3->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StartBody = new wxIntTextCtrl(Panel1, ID_StartBody, _("0"), wxDefaultPosition, wxSize(64,-1), 0, wxDefaultValidator, _T("ID_StartBody"));
	StartBody->Disable();
	FlexGridSizer3->Add(StartBody, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer2 = new wxBoxSizer(wxVERTICAL);
	Veggy = new wxCheckBox(Panel1, ID_Veggy, _("Vegetable (Autotroph)"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_Veggy"));
	Veggy->SetValue(false);
	Veggy->Disable();
	BoxSizer2->Add(Veggy, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Fixed = new wxCheckBox(Panel1, ID_Fixed, _("Fixed (Movement disabled)"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_Fixed"));
	Fixed->SetValue(false);
	Fixed->Disable();
	BoxSizer2->Add(Fixed, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	NoVis = new wxCheckBox(Panel1, ID_NoVis, _("Disable vision"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_NoVis"));
	NoVis->SetValue(false);
	NoVis->Disable();
	BoxSizer2->Add(NoVis, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	NoExec = new wxCheckBox(Panel1, ID_NoExec, _("Disable DNA execution"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_NoExec"));
	NoExec->SetValue(false);
	NoExec->Disable();
	BoxSizer2->Add(NoExec, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(BoxSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer10->Add(FlexGridSizer2, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL, 0);
	Panel1->SetSizer(FlexGridSizer10);
	FlexGridSizer10->Fit(Panel1);
	FlexGridSizer10->SetSizeHints(Panel1);
	Panel2 = new wxPanel(Notebook1, ID_PANEL2, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL2"));
	FlexGridSizer6 = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer13 = new wxFlexGridSizer(0, 3, 0, 0);
	StaticBoxSizer1 = new wxStaticBoxSizer(wxHORIZONTAL, Panel2, _("Field settings"));
	FlexGridSizer4 = new wxFlexGridSizer(2, 2, 0, 0);
	StaticText4 = new wxStaticText(Panel2, ID_STATICTEXT4, _("Width"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer4->Add(StaticText4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FieldWidth = new wxIntTextCtrl(Panel2, ID_FieldWidth, _("8000"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_FieldWidth"));
	FlexGridSizer4->Add(FieldWidth, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText5 = new wxStaticText(Panel2, ID_STATICTEXT5, _("Height"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT5"));
	FlexGridSizer4->Add(StaticText5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FieldHeight = new wxIntTextCtrl(Panel2, ID_FieldHeight, _("6000"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_FieldHeight"));
	FlexGridSizer4->Add(FieldHeight, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer13->Add(StaticBoxSizer1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer2 = new wxStaticBoxSizer(wxHORIZONTAL, Panel2, _("Population settings"));
	FlexGridSizer5 = new wxFlexGridSizer(4, 2, 0, 0);
	StaticText6 = new wxStaticText(Panel2, ID_STATICTEXT6, _("Maximum non-veggy population"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT6"));
	FlexGridSizer5->Add(StaticText6, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	MaxNonVeg = new wxIntTextCtrl(Panel2, ID_MaxNonVeg, _("200"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_MaxNonVeg"));
	FlexGridSizer5->Add(MaxNonVeg, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText7 = new wxStaticText(Panel2, ID_STATICTEXT7, _("Maximum veggy population"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT7"));
	FlexGridSizer5->Add(StaticText7, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	MaxVeg = new wxIntTextCtrl(Panel2, ID_MaxVeg, _("100"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_MaxVeg"));
	FlexGridSizer5->Add(MaxVeg, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText8 = new wxStaticText(Panel2, ID_STATICTEXT8, _("Veggy repopulation threshold"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT8"));
	FlexGridSizer5->Add(StaticText8, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	VegRepopThreshold = new wxIntTextCtrl(Panel2, ID_VegRepopThreshold, _("70"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_VegRepopThreshold"));
	FlexGridSizer5->Add(VegRepopThreshold, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText9 = new wxStaticText(Panel2, ID_STATICTEXT9, _("Veggy repopulation amount"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT9"));
	FlexGridSizer5->Add(StaticText9, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	VegRepopAmount = new wxIntTextCtrl(Panel2, ID_VegRepopAmount, _("20"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_VegRepopAmount"));
	FlexGridSizer5->Add(VegRepopAmount, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText25 = new wxStaticText(Panel2, ID_STATICTEXT25, _("Veggy repopulation cooldown"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT25"));
	FlexGridSizer5->Add(StaticText25, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	VegRepopCooldown = new wxIntTextCtrl(Panel2, ID_VegRepopCooldown, _("20"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_VegRepopCooldown"));
	FlexGridSizer5->Add(VegRepopCooldown, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer2->Add(FlexGridSizer5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer13->Add(StaticBoxSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6->Add(FlexGridSizer13, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer3 = new wxStaticBoxSizer(wxHORIZONTAL, Panel2, _("Veggy feeding"));
	VegNrg = new wxIntTextCtrl(Panel2, ID_VegNrg, _("100"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_VegNrg"));
	StaticBoxSizer3->Add(VegNrg, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer14 = new wxFlexGridSizer(0, 2, 0, 0);
	StaticText10 = new wxStaticText(Panel2, ID_STATICTEXT10, _("NRG per"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT10"));
	FlexGridSizer14->Add(StaticText10, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer6 = new wxBoxSizer(wxVERTICAL);
	NrgPerCycle = new wxRadioButton(Panel2, ID_NrgPerCycle, _("cycle"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_NrgPerCycle"));
	NrgPerCycle->SetValue(true);
	BoxSizer6->Add(NrgPerCycle, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	NrgPerKilobody = new wxRadioButton(Panel2, ID_NrgPerKilobody, _("kilobody point"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_NrgPerKilobody"));
	BoxSizer6->Add(NrgPerKilobody, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer14->Add(BoxSizer6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer3->Add(FlexGridSizer14, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6->Add(StaticBoxSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Panel2->SetSizer(FlexGridSizer6);
	FlexGridSizer6->Fit(Panel2);
	FlexGridSizer6->SetSizeHints(Panel2);
	Panel3 = new wxPanel(Notebook1, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL3"));
	FlexGridSizer7 = new wxFlexGridSizer(1, 3, 0, 0);
	FlexGridSizer7->AddGrowableCol(0);
	FlexGridSizer7->AddGrowableCol(2);
	FlexGridSizer7->Add(-1,-1,1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer8 = new wxFlexGridSizer(0, 2, 0, 0);
	StaticText11 = new wxStaticText(Panel3, ID_STATICTEXT11, _("Coefficient of friction"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT11"));
	FlexGridSizer8->Add(StaticText11, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	Friction = new wxFloatTextCtrl(Panel3, ID_Friction, _("0.1"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_Friction"));
	FlexGridSizer8->Add(Friction, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText12 = new wxStaticText(Panel3, ID_STATICTEXT12, _("Bot density"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT12"));
	FlexGridSizer8->Add(StaticText12, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	Density = new wxFloatTextCtrl(Panel3, ID_Density, _("1"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_Density"));
	FlexGridSizer8->Add(Density, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText13 = new wxStaticText(Panel3, ID_STATICTEXT13, _("Bot elasticity"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT13"));
	FlexGridSizer8->Add(StaticText13, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	Elast = new wxFloatTextCtrl(Panel3, ID_Elast, _("0.7"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_Elast"));
	FlexGridSizer8->Add(Elast, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText23 = new wxStaticText(Panel3, ID_STATICTEXT23, _("Movement efficiency"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT23"));
	FlexGridSizer8->Add(StaticText23, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	MoveEff = new wxFloatTextCtrl(Panel3, ID_MoveEff, _("0.8"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_MoveEff"));
	FlexGridSizer8->Add(MoveEff, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText24 = new wxStaticText(Panel3, ID_STATICTEXT24, _("Maximum velocity"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT24"));
	FlexGridSizer8->Add(StaticText24, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	MaxVel = new wxIntTextCtrl(Panel3, ID_MaxVel, _("100"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_MaxVel"));
	FlexGridSizer8->Add(MaxVel, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer7->Add(FlexGridSizer8, 0, wxALIGN_TOP|wxALIGN_CENTER_HORIZONTAL, 0);
	FlexGridSizer7->Add(-1,-1,1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Panel3->SetSizer(FlexGridSizer7);
	FlexGridSizer7->Fit(Panel3);
	FlexGridSizer7->SetSizeHints(Panel3);
	Panel4 = new wxPanel(Notebook1, ID_PANEL4, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL4"));
	FlexGridSizer12 = new wxFlexGridSizer(1, 3, 0, 0);
	FlexGridSizer12->AddGrowableCol(0);
	FlexGridSizer12->AddGrowableCol(2);
	FlexGridSizer12->Add(-1,-1,1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer9 = new wxFlexGridSizer(9, 2, 0, 0);
	StaticText14 = new wxStaticText(Panel4, ID_STATICTEXT14, _("Store cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT14"));
	FlexGridSizer9->Add(StaticText14, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	StoreCost = new wxFloatTextCtrl(Panel4, ID_StoreCost, _("0.04"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_StoreCost"));
	FlexGridSizer9->Add(StoreCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText15 = new wxStaticText(Panel4, ID_STATICTEXT15, _("Movement cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT15"));
	FlexGridSizer9->Add(StaticText15, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	MovCost = new wxFloatTextCtrl(Panel4, ID_MovCost, _("0.05"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_MovCost"));
	FlexGridSizer9->Add(MovCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText16 = new wxStaticText(Panel4, ID_STATICTEXT16, _("Age cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT16"));
	FlexGridSizer9->Add(StaticText16, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	AgeCost = new wxFloatTextCtrl(Panel4, ID_AgeCost, _("0.0001"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_AgeCost"));
	FlexGridSizer9->Add(AgeCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText17 = new wxStaticText(Panel4, ID_STATICTEXT17, _("Shot cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT17"));
	FlexGridSizer9->Add(StaticText17, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	ShotCost = new wxFloatTextCtrl(Panel4, ID_ShotCost, _("2"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_ShotCost"));
	FlexGridSizer9->Add(ShotCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText18 = new wxStaticText(Panel4, ID_STATICTEXT18, _("Body upkeep"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT18"));
	FlexGridSizer9->Add(StaticText18, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	BodyUpkeepCost = new wxFloatTextCtrl(Panel4, ID_BodyUpkeepCost, _("0.0001"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BodyUpkeepCost"));
	FlexGridSizer9->Add(BodyUpkeepCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText19 = new wxStaticText(Panel4, ID_STATICTEXT19, _("Poison cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT19"));
	FlexGridSizer9->Add(StaticText19, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	PoisonCost = new wxFloatTextCtrl(Panel4, ID_PoisonCost, _("0.01"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_PoisonCost"));
	FlexGridSizer9->Add(PoisonCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText20 = new wxStaticText(Panel4, ID_STATICTEXT20, _("Venom cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT20"));
	FlexGridSizer9->Add(StaticText20, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	VenomCost = new wxFloatTextCtrl(Panel4, ID_VenomCost, _("0.01"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_VenomCost"));
	FlexGridSizer9->Add(VenomCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText21 = new wxStaticText(Panel4, ID_STATICTEXT21, _("Slime cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT21"));
	FlexGridSizer9->Add(StaticText21, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	SlimeCost = new wxFloatTextCtrl(Panel4, ID_SlimeCost, _("0.1"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_SlimeCost"));
	FlexGridSizer9->Add(SlimeCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText22 = new wxStaticText(Panel4, ID_STATICTEXT22, _("Shell cost"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT22"));
	FlexGridSizer9->Add(StaticText22, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	ShellCost = new wxFloatTextCtrl(Panel4, ID_ShellCost, _("0.1"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_ShellCost"));
	FlexGridSizer9->Add(ShellCost, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer12->Add(FlexGridSizer9, 0, wxALL|wxALIGN_TOP|wxALIGN_CENTER_HORIZONTAL, 5);
	FlexGridSizer12->Add(-1,-1,1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Panel4->SetSizer(FlexGridSizer12);
	FlexGridSizer12->Fit(Panel4);
	FlexGridSizer12->SetSizeHints(Panel4);
	Notebook1->AddPage(Panel1, _("Bots"), false);
	Notebook1->AddPage(Panel2, _("General Options"), false);
	Notebook1->AddPage(Panel3, _("Physics"), false);
	Notebook1->AddPage(Panel4, _("Costs"), false);
	FlexGridSizer1->Add(Notebook1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StdDialogButtonSizer1 = new wxStdDialogButtonSizer();
	StdDialogButtonSizer1->AddButton(new wxButton(this, wxID_OK, wxEmptyString));
	StdDialogButtonSizer1->AddButton(new wxButton(this, wxID_CANCEL, wxEmptyString));
	StdDialogButtonSizer1->Realize();
	FlexGridSizer1->Add(StdDialogButtonSizer1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);
	Center();

	Connect(ID_Bots,wxEVT_COMMAND_LIST_ITEM_SELECTED,(wxObjectEventFunction)&NewDialog::OnListCtrl1ItemSelect);
	Connect(ID_Bots,wxEVT_COMMAND_LIST_ITEM_DESELECTED,(wxObjectEventFunction)&NewDialog::OnListCtrl1ItemDeselect);
	Connect(ID_AddBot,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&NewDialog::OnButton2Click);
	Connect(ID_DelBot,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&NewDialog::RemoveBot);
	Connect(ID_DelAll,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&NewDialog::RemoveAllBots);
	Connect(ID_Color,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&NewDialog::SetBotColor);
	Connect(ID_NumBots,wxEVT_COMMAND_TEXT_UPDATED,(wxObjectEventFunction)&NewDialog::OnBotSettingChange2);
	Connect(ID_StartNrg,wxEVT_COMMAND_TEXT_UPDATED,(wxObjectEventFunction)&NewDialog::OnBotSettingChange2);
	Connect(ID_StartBody,wxEVT_COMMAND_TEXT_UPDATED,(wxObjectEventFunction)&NewDialog::OnBotSettingChange2);
	Connect(ID_Veggy,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&NewDialog::OnBotSettingChange2);
	Connect(ID_Fixed,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&NewDialog::OnBotSettingChange2);
	Connect(ID_NoVis,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&NewDialog::OnBotSettingChange2);
	Connect(ID_NoExec,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&NewDialog::OnBotSettingChange2);
	Connect(wxID_ANY,wxEVT_INIT_DIALOG,(wxObjectEventFunction)&NewDialog::OnInit);
	//*)
}

NewDialog::~NewDialog()
{
	//(*Destroy(NewDialog)
	//*)
}

void NewDialog::SetFromSettings(const SimSettings &prefs) {
	FieldWidth->ChangeValue(wxString::Format(_T("%d"), prefs.width));
	FieldHeight->ChangeValue(wxString::Format(_T("%d"), prefs.height));
	MaxNonVeg->ChangeValue(wxString::Format(_T("%d"), prefs.maxnonveg));
	MaxVeg->ChangeValue(wxString::Format(_T("%d"), prefs.maxveg));
	VegRepopThreshold->ChangeValue(wxString::Format(_T("%d"), prefs.vegrepop_threshold));
	VegRepopAmount->ChangeValue(wxString::Format(_T("%d"), prefs.vegrepop_amount));
	VegRepopCooldown->ChangeValue(wxString::Format(_T("%d"), prefs.vegrepop_cooldown));
	VegNrg->ChangeValue(wxString::Format(_T("%d"), prefs.vegfeed));
	switch(prefs.vegfeed_type) {
		default:
		case NRG_PER_CYCLE:
			NrgPerCycle->SetValue(true);
			break;
		case NRG_PER_KILOBODY:
			NrgPerKilobody->SetValue(true);
			break;
	}
	Friction->ChangeValue(wxString::Format(_T("%.2f"), prefs.friction));
	Density->ChangeValue(wxString::Format(_T("%.2f"), prefs.botdensity));
	Elast->ChangeValue(wxString::Format(_T("%.2f"), prefs.elast));
	MoveEff->ChangeValue(wxString::Format(_T("%.2f"), prefs.move_eff));
	MaxVel->ChangeValue(wxString::Format(_T("%d"), prefs.maxvel));

	StoreCost->ChangeValue(wxString::Format(_T("%.2f"), prefs.storecost));
	MovCost->ChangeValue(wxString::Format(_T("%.2f"), prefs.movcost));
	AgeCost->ChangeValue(wxString::Format(_T("%.6f"), prefs.agecost));
	ShotCost->ChangeValue(wxString::Format(_T("%.2f"), prefs.shotcost));
	BodyUpkeepCost->ChangeValue(wxString::Format(_T("%.6f"), prefs.bodyupkeepcost));
	PoisonCost->ChangeValue(wxString::Format(_T("%.2f"), prefs.poisoncost));
	VenomCost->ChangeValue(wxString::Format(_T("%.2f"), prefs.venomcost));
	SlimeCost->ChangeValue(wxString::Format(_T("%.2f"), prefs.slimecost));
	ShellCost->ChangeValue(wxString::Format(_T("%.2f"), prefs.shellcost));
	botlist = prefs.templates;
	for (std::vector<BotTemplate>::iterator p = botlist.begin(); p != botlist.end(); ++p) {
		Bots->InsertItem(Bots->GetItemCount(), wxString(p->name.c_str(), wxConvUTF8));
	}
}

/*inline int StrToInt(wxString &str) {
	long temp;
	str.ToLong(&temp);
	return temp;
}*/

void NewDialog::SaveToSettings(SimSettings &prefs) const {
	prefs.width = strtoul(FieldWidth->GetValue().ToAscii(), NULL, 10);
	prefs.height = strtoul(FieldHeight->GetValue().ToAscii(), NULL, 10);
	prefs.maxnonveg = strtoul(MaxNonVeg->GetValue().ToAscii(), NULL, 10);
	prefs.maxveg = strtoul(MaxVeg->GetValue().ToAscii(), NULL, 10);
	prefs.vegrepop_threshold = strtoul(VegRepopThreshold->GetValue().ToAscii(), NULL, 10);
	prefs.vegrepop_amount = strtoul(VegRepopAmount->GetValue().ToAscii(), NULL, 10);
	prefs.vegrepop_cooldown = strtoul(VegRepopCooldown->GetValue().ToAscii(), NULL, 10);
	prefs.vegfeed = strtoul(VegNrg->GetValue().ToAscii(), NULL, 10);
	if (NrgPerCycle->GetValue()) {
		prefs.vegfeed_type = NRG_PER_CYCLE;
	} else if (NrgPerKilobody->GetValue()) {
		prefs.vegfeed_type = NRG_PER_KILOBODY;
	}
	prefs.friction = (float) strtod(Friction->GetValue().ToAscii(), NULL);
	prefs.botdensity = (float) strtod(Density->GetValue().ToAscii(), NULL);
	prefs.elast = (float) strtod(Elast->GetValue().ToAscii(), NULL);
	prefs.move_eff = (float) strtod(MoveEff->GetValue().ToAscii(), NULL);
	prefs.maxvel = strtoul(MaxVel->GetValue().ToAscii(), NULL, 10);

	prefs.storecost = (float) strtod(StoreCost->GetValue().ToAscii(), NULL);
	prefs.movcost = (float) strtod(MovCost->GetValue().ToAscii(), NULL);
	prefs.agecost = (float) strtod(AgeCost->GetValue().ToAscii(), NULL);
	prefs.shotcost = (float) strtod(ShotCost->GetValue().ToAscii(), NULL);
	prefs.bodyupkeepcost = (float) strtod(BodyUpkeepCost->GetValue().ToAscii(), NULL);
	prefs.venomcost = (float) strtod(VenomCost->GetValue().ToAscii(), NULL);
	prefs.poisoncost = (float) strtod(PoisonCost->GetValue().ToAscii(), NULL);
	prefs.slimecost = (float) strtod(SlimeCost->GetValue().ToAscii(), NULL);
	prefs.shellcost = (float) strtod(ShellCost->GetValue().ToAscii(), NULL);
	prefs.templates = botlist;
}


void NewDialog::OnButton2Click(wxCommandEvent& event)
{
	wxFileDialog dialog(this, _T("Select bot file"), _T(""), _T(""), _T("Bot text files (*.txt)|*.txt"), wxFD_OPEN | wxFD_FILE_MUST_EXIST | wxFD_CHANGE_DIR);
	if (dialog.ShowModal() == wxID_OK) {
		wxFileName path(dialog.GetPath());
		if (path.IsOk() && path.FileExists() && path.IsFileReadable()) {
			BotTemplate temp;
			Bots->InsertItem(Bots->GetItemCount(), path.GetFullName());
			temp.name = std::string(path.GetFullName().mb_str());
			//temp.fname = path.GetFullPath();
			temp.code = Code::ptr(new Code(std::string(path.GetFullPath().mb_str())));
			srand(time(NULL));
			temp.color[0] = randf(0.0f, 1.0f);
			temp.color[1] = randf(0.0f, 1.0f);
			temp.color[2] = randf(0.0f, 1.0f);
			temp.numbots = 15;
			temp.nrg = 3000.0;
			temp.body = 1000.0;
			temp.veg = false;
			temp.fixed = false;
			temp.novis = false;
			temp.noexec = false;
			botlist.push_back(temp);
		}
	}
}

void NewDialog::OnInit(wxInitDialogEvent& event)
{
}

void NewDialog::OnListCtrl1ItemSelect(wxListEvent& event) {
	long item = -1;
	item = Bots->GetNextItem(item, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);

	NumBots->Enable();
	NumBots->ChangeValue(wxString::Format(_T("%d"), botlist.at(item).numbots));
	StartNrg->Enable();
	StartNrg->ChangeValue(wxString::Format(_T("%.0f"), botlist.at(item).nrg));
	StartBody->Enable();
	StartBody->ChangeValue(wxString::Format(_T("%.0f"), botlist.at(item).body));

	Veggy->Enable();
	Veggy->SetValue(botlist.at(item).veg);
	Fixed->Enable();
	Fixed->SetValue(botlist.at(item).fixed);
	NoVis->Enable();
	NoVis->SetValue(botlist.at(item).novis);
	NoExec->Enable();
	NoExec->SetValue(botlist.at(item).noexec);

	DelBot->Enable();
	Color->Enable();
}

void NewDialog::DisableBotFields() {
	NumBots->Disable();
	StartNrg->Disable();
	StartBody->Disable();
	Veggy->Disable();
	Fixed->Disable();
	NoVis->Disable();
	NoExec->Disable();
	DelBot->Disable();
	Color->Disable();
}

void NewDialog::OnListCtrl1ItemDeselect(wxListEvent& event) {
	DisableBotFields();
}

void NewDialog::OnBotSettingChange2(wxCommandEvent& event) {
	SetSettings();
}

void NewDialog::SetSettings() {
	wxCheckBox *check;
	long temp, item = -1;
	item = Bots->GetNextItem(item, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);

	if (NumBots->GetValue().ToLong(&temp)) botlist.at(item).numbots = temp;
	if (StartNrg->GetValue().ToLong(&temp)) botlist.at(item).nrg = temp;
	if (StartBody->GetValue().ToLong(&temp)) botlist.at(item).body = temp;

	botlist.at(item).veg = Veggy->GetValue();
	botlist.at(item).fixed = Veggy->GetValue();
	botlist.at(item).novis = Veggy->GetValue();
	botlist.at(item).noexec = Veggy->GetValue();
}

void NewDialog::RemoveBot(wxCommandEvent& event)
{
	long item = -1;
	item = Bots->GetNextItem(item, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);
	if (item == -1) return;
	int32 size = botlist.size()-1;
	for (int32 i = item; i < size; ++i)
		botlist.at(i) = botlist.at(i+1);
	botlist.pop_back();
	Bots->DeleteItem(item);
	DisableBotFields();
}

void NewDialog::RemoveAllBots(wxCommandEvent& event)
{
	Bots->DeleteAllItems();
	botlist.resize(0);
	DisableBotFields();
}

void NewDialog::SetBotColor(wxCommandEvent& event) {
	long item = -1;
	item = Bots->GetNextItem(item, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);
	if (item != -1) {
		BotTemplate &b = botlist.at(item);
		wxColourData c;
		c.SetColour(wxColour(b.color[0]*255, b.color[1]*255, b.color[2]*255));
		wxColourDialog d(this, &c);
		if (d.ShowModal() == wxID_OK) {
			wxColour &c = d.GetColourData().GetColour();
			b.color[0] = c.Red()/255.0f;
			b.color[1] = c.Green()/255.0f;
			b.color[2] = c.Blue()/255.0f;
		}
	}
}
