#include "BotProperties.h"

//(*InternalHeaders(BotProperties)
#include <wx/string.h>
#include <wx/intl.h>
//*)

#include "struct.h"

//(*IdInit(BotProperties)
const long BotProperties::ID_BotName = wxNewId();
const long BotProperties::ID_STATICTEXT2 = wxNewId();
const long BotProperties::ID_BotAge = wxNewId();
const long BotProperties::ID_STATICTEXT4 = wxNewId();
const long BotProperties::ID_BotNrg = wxNewId();
const long BotProperties::ID_STATICTEXT6 = wxNewId();
const long BotProperties::ID_BotBody = wxNewId();
const long BotProperties::ID_STATICTEXT8 = wxNewId();
const long BotProperties::ID_BotPoison = wxNewId();
const long BotProperties::ID_STATICTEXT10 = wxNewId();
const long BotProperties::ID_BotVenom = wxNewId();
const long BotProperties::ID_STATICTEXT12 = wxNewId();
const long BotProperties::ID_BotShell = wxNewId();
const long BotProperties::ID_STATICTEXT3 = wxNewId();
const long BotProperties::ID_BotSlime = wxNewId();
const long BotProperties::ID_STATICTEXT5 = wxNewId();
const long BotProperties::ID_BotMass = wxNewId();
const long BotProperties::ID_STATICTEXT9 = wxNewId();
const long BotProperties::ID_BotVel = wxNewId();
const long BotProperties::ID_STATICTEXT1 = wxNewId();
const long BotProperties::ID_BotKills = wxNewId();
const long BotProperties::ID_BotRepro = wxNewId();
const long BotProperties::ID_BotKill = wxNewId();
const long BotProperties::ID_BotDNA = wxNewId();
const long BotProperties::ID_BotMem = wxNewId();
const long BotProperties::ID_View = wxNewId();
const long BotProperties::ID_CloseDisplay = wxNewId();
//*)

BEGIN_EVENT_TABLE(BotProperties,wxDialog)
	//(*EventTable(BotProperties)
	//*)
END_EVENT_TABLE()

BotProperties::BotProperties(wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size) : state(ShowNothing)
{
	//(*Initialize(BotProperties)
	wxStaticBoxSizer* StaticBoxSizer2;
	wxGridSizer* GridSizer1;
	wxFlexGridSizer* FlexGridSizer1;
	wxFlexGridSizer* FlexGridSizer2;
	wxStaticText* StaticText13;
	wxStaticText* StaticText15;
	wxStaticText* StaticText17;
	wxButton* BotMem;
	wxStaticText* StaticText3;
	wxFlexGridSizer* FlexGridSizer3;
	wxButton* BotKill;
	wxStaticText* StaticText7;
	wxButton* BotRepro;
	wxStaticText* StaticText5;
	wxStaticText* StaticText2;
	wxButton* BotDNA;
	wxStaticText* StaticText19;
	wxStaticText* StaticText9;
	wxStaticText* StaticText11;
	wxStaticBoxSizer* StaticBoxSizer1;

	Create(parent, wxID_ANY, _("Bot Properties"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(0, 3, 0, 0);
	FlexGridSizer3 = new wxFlexGridSizer(0, 1, 0, 0);
	BotName = new wxStaticText(this, ID_BotName, _("\?\?\?"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotName"));
	FlexGridSizer3->Add(BotName, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer1 = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Bot status"));
	FlexGridSizer2 = new wxFlexGridSizer(0, 2, 0, 0);
	FlexGridSizer2->AddGrowableCol(0);
	FlexGridSizer2->AddGrowableCol(1);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT2, _("Age"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer2->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotAge = new wxStaticText(this, ID_BotAge, _("0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotAge"));
	FlexGridSizer2->Add(BotAge, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText5 = new wxStaticText(this, ID_STATICTEXT4, _("Energy"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer2->Add(StaticText5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotNrg = new wxStaticText(this, ID_BotNrg, _("0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotNrg"));
	FlexGridSizer2->Add(BotNrg, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText7 = new wxStaticText(this, ID_STATICTEXT6, _("Body"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT6"));
	FlexGridSizer2->Add(StaticText7, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotBody = new wxStaticText(this, ID_BotBody, _("0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotBody"));
	FlexGridSizer2->Add(BotBody, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText9 = new wxStaticText(this, ID_STATICTEXT8, _("Poison"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT8"));
	FlexGridSizer2->Add(StaticText9, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotPoison = new wxStaticText(this, ID_BotPoison, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotPoison"));
	FlexGridSizer2->Add(BotPoison, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText11 = new wxStaticText(this, ID_STATICTEXT10, _("Venom"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT10"));
	FlexGridSizer2->Add(StaticText11, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotVenom = new wxStaticText(this, ID_BotVenom, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotVenom"));
	FlexGridSizer2->Add(BotVenom, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText13 = new wxStaticText(this, ID_STATICTEXT12, _("Shell"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT12"));
	FlexGridSizer2->Add(StaticText13, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotShell = new wxStaticText(this, ID_BotShell, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotShell"));
	FlexGridSizer2->Add(BotShell, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText15 = new wxStaticText(this, ID_STATICTEXT3, _("Slime"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer2->Add(StaticText15, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotSlime = new wxStaticText(this, ID_BotSlime, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotSlime"));
	FlexGridSizer2->Add(BotSlime, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText17 = new wxStaticText(this, ID_STATICTEXT5, _("Mass"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT5"));
	FlexGridSizer2->Add(StaticText17, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotMass = new wxStaticText(this, ID_BotMass, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotMass"));
	FlexGridSizer2->Add(BotMass, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText19 = new wxStaticText(this, ID_STATICTEXT9, _("Velocity"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT9"));
	FlexGridSizer2->Add(StaticText19, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotVel = new wxStaticText(this, ID_BotVel, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotVel"));
	FlexGridSizer2->Add(BotVel, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT1, _("Kills"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer2->Add(StaticText2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotKills = new wxStaticText(this, ID_BotKills, _("0"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_BotKills"));
	FlexGridSizer2->Add(BotKills, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3->Add(StaticBoxSizer1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer2 = new wxStaticBoxSizer(wxHORIZONTAL, this, _("Actions"));
	BotRepro = new wxButton(this, ID_BotRepro, _("Reproduce"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BotRepro"));
	StaticBoxSizer2->Add(BotRepro, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotKill = new wxButton(this, ID_BotKill, _("Kill"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BotKill"));
	StaticBoxSizer2->Add(BotKill, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3->Add(StaticBoxSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	GridSizer1 = new wxGridSizer(0, 2, 0, 0);
	BotDNA = new wxButton(this, ID_BotDNA, _("Bot DNA"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BotDNA"));
	GridSizer1->Add(BotDNA, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BotMem = new wxButton(this, ID_BotMem, _("Bot memory"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BotMem"));
	GridSizer1->Add(BotMem, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3->Add(GridSizer1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ViewSizer = new wxFlexGridSizer(2, 1, 0, 0);
	ViewSizer->AddGrowableRow(0);
	View = new wxTextCtrl(this, ID_View, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY, wxDefaultValidator, _T("ID_View"));
	View->SetMinSize(wxDLG_UNIT(this,wxSize(100,-1)));
	View->Hide();
	ViewSizer->Add(View, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CloseDisplay = new wxButton(this, ID_CloseDisplay, _("Hide"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CloseDisplay"));
	CloseDisplay->Hide();
	ViewSizer->Add(CloseDisplay, 1, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(ViewSizer, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BotDNA,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&BotProperties::ButtonShowDNA);
	Connect(ID_BotMem,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&BotProperties::ButtonShowMemory);
	Connect(ID_CloseDisplay,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&BotProperties::ButtonShowNothing);
	Connect(wxID_ANY,wxEVT_INIT_DIALOG,(wxObjectEventFunction)&BotProperties::OnInit);
	//*)
}

BotProperties::~BotProperties()
{
	//(*Destroy(BotProperties)
	//*)
}


void BotProperties::OnInit(wxInitDialogEvent& event)
{
}

void BotProperties::SetLabels(Bot& bot) {
	BotName->SetLabel(wxString(bot.name.c_str(), wxConvUTF8));
	BotAge->SetLabel(wxString::Format(_T("%d"), bot.robage));
	BotNrg->SetLabel(wxString::Format(_T("%.2f"), bot.nrg));
	BotBody->SetLabel(wxString::Format(_T("%.2f"), bot.body));
	BotPoison->SetLabel(wxString::Format(_T("%.2f"), bot.poison));
	BotVenom->SetLabel(wxString::Format(_T("%.2f"), bot.venom));
	BotShell->SetLabel(wxString::Format(_T("%.2f"), bot.shell));
	BotSlime->SetLabel(wxString::Format(_T("%.2f"), bot.slime));
	BotMass->SetLabel(wxString::Format(_T("%.2f"), bot.Mass()));
	BotVel->SetLabel(wxString::Format(_T("%.2f"), bot.b_body->GetLinearVelocity().Length()));
	BotKills->SetLabel(wxString::Format(_T("%d"), bot.kills));
	Fit();
}

void BotProperties::ButtonShowDNA(wxCommandEvent& event) {
	state = ShowDNA;
	ViewSizer->Show((size_t)0);
	ViewSizer->Show((size_t)1);
	ViewSizer->Layout();
	Layout();
	Fit();
}

void BotProperties::ButtonShowMemory(wxCommandEvent& event) {
	state = ShowMem;
	ViewSizer->Show((size_t)0);
	ViewSizer->Show((size_t)1);
	ViewSizer->Layout();
	Layout();
	Fit();
}

void BotProperties::ButtonShowNothing(wxCommandEvent& event) {
	state = ShowNothing;
	ViewSizer->Hide((size_t)0);
	ViewSizer->Hide((size_t)1);
	ViewSizer->Layout();
	Layout();
	Fit();
}
