#include <vector>
#include <iterator>

// somewhat crappy pointer container, but Boost's was unusable
template<typename T> class ptr_vector {
private:
	std::vector<T*> ptrs;
public:
/*	template<typename U> class iterator : public std::iterator<std::random_access_iterator_tag, U> {
		std::vector<U*>::iterator it;
		iterator(std::vector<U*>::iterator _it) : it(_it) { }
//		friend class ptr_vector;
	public:
		iterator(ptr_vector<U>::iterator& a) : it(a.it) { }

		iterator& operator =(iterator& b) { it = b.it; return *this; }

		iterator& operator ++() { ++it; return *this; }
		iterator operator ++(int) { return iterator(it++); }

		bool operator ==(iterator& b) const { return it == b.it; }
		bool operator !=(iterator& b) const { return it != b.it; }

		T& operator *() const { return **it; }
		T* operator ->() const { return *it; }

		iterator& operator --() { --it; return *this; }
		iterator operator --(int) { return iterator(it--); }

		iterator operator +(int b) const { iterator tmp(it); tmp.it += b; return tmp; }
		friend iterator operator +(int b, const iterator& a) { return a+b; }
		iterator operator -(int b) const { iterator tmp(it); tmp.it -= b; return tmp; }
		int operator -(const iterator& b) { return it-b.it; }

		bool operator <(iterator& b) const { return it < b.it; }
		bool operator >(iterator& b) const { return it > b.it; }

		iterator& operator +=(int b) const { it += b; return *this; }
		iterator& operator -=(int b) const { it -= b; return *this; }
	};*/

	T& at(size_t i) {
		return *ptrs.at(i);
	}
	T& operator[](size_t i) {
		return at(i);
	}
	const T& at(size_t i) const {
		return *ptrs.at(i);
	}
	const T& operator[](size_t i) const {
		return at(i);
	}

	T* ptr_at(size_t i) {
		return ptrs.at(i);
	}
	const T* ptr_at(size_t i) const {
		return ptrs.at(i);
	}

//	iterator<T> begin() const {
//		return iterator(ptrs.begin());
//	}
//	iterator<T> end() const {
//		return iterator(ptrs.end());
//	}

	T& front() {
		return *ptrs.front();
	}
	T& back() {
		return *ptrs.back();
	}
	const T& front() const {
		return *ptrs.front();
	}
	const T& back() const {
		return *ptrs.back();
	}

	void swap(size_t id, size_t id2) {
		T* tmp = ptrs.at(id);
		ptrs.at(id) = ptrs.at(id2);
		ptrs.at(id2) = tmp;
	}

	void push_back(T* item) {
		ptrs.push_back(item);
	}
	void pop_back() {
		delete ptrs.back();
		ptrs.pop_back();
	}
	T& new_end() {
		T* tmp = new T;
		ptrs.push_back(tmp);
		return *tmp;
	}

	bool empty() const {
		return ptrs.empty();
	}
	void clear() {
		while (!empty()) pop_back();
	}

	size_t size() const {
		return ptrs.size();
	}
	void resize(size_t new_size) {
		while (size() > new_size) {
			pop_back();
		}
		while (size() < new_size) {
			push_back(new T);
		}
	}

	ptr_vector() { }
	~ptr_vector() { if (!empty()) clear(); }
};
